# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`etcd`](#etcd): Manage etcd

## Classes

### <a name="etcd"></a>`etcd`

Manage etcd

#### Examples

##### 

```puppet
include etcd
```

#### Parameters

The following parameters are available in the `etcd` class:

* [`version`](#version)
* [`base_url`](#base_url)
* [`os`](#os)
* [`arch`](#arch)
* [`download_url`](#download_url)
* [`download_dir`](#download_dir)
* [`extract_dir`](#extract_dir)
* [`bin_dir`](#bin_dir)
* [`manage_user`](#manage_user)
* [`manage_group`](#manage_group)
* [`user`](#user)
* [`user_uid`](#user_uid)
* [`group`](#group)
* [`group_gid`](#group_gid)
* [`config_path`](#config_path)
* [`config`](#config)
* [`max_open_files`](#max_open_files)

##### <a name="version"></a>`version`

Data type: `String`

Version of etcd to install
Not used if download_url is defined.

Default value: `'3.4.7'`

##### <a name="base_url"></a>`base_url`

Data type: `Stdlib::HTTPUrl`

Base URL of where to download etcd binaries.
Not used if download_url is defined.

Default value: `'https://github.com/etcd-io/etcd/releases/download'`

##### <a name="os"></a>`os`

Data type: `String[1]`

The GOOS to install
Not used if download_url is defined.

Default value: `downcase($facts['kernel'])`

##### <a name="arch"></a>`arch`

Data type: `String[1]`

The GOARCH to install
Not used if download_url is defined.

Default value: `$facts['os']['architecture']`

##### <a name="download_url"></a>`download_url`

Data type: `Optional[Stdlib::HTTPUrl]`

Alternative location to download etcd binaries

Default value: ``undef``

##### <a name="download_dir"></a>`download_dir`

Data type: `Stdlib::Absolutepath`

The directory of where to download etcd

Default value: `'/tmp'`

##### <a name="extract_dir"></a>`extract_dir`

Data type: `Stdlib::Absolutepath`

The directory where to extract etcd

Default value: `'/opt'`

##### <a name="bin_dir"></a>`bin_dir`

Data type: `Stdlib::Absolutepath`

The path to bin directory for etcd and etcdctl symlinks

Default value: `'/usr/bin'`

##### <a name="manage_user"></a>`manage_user`

Data type: `Boolean`

Boolean that determines if etcd user is managed

Default value: ``true``

##### <a name="manage_group"></a>`manage_group`

Data type: `Boolean`

Boolean that determines if etcd group is managed

Default value: ``true``

##### <a name="user"></a>`user`

Data type: `String[1]`

The etcd user

Default value: `'etcd'`

##### <a name="user_uid"></a>`user_uid`

Data type: `Optional[Integer]`

The etcd user UID

Default value: ``undef``

##### <a name="group"></a>`group`

Data type: `String[1]`

The etcd group

Default value: `'etcd'`

##### <a name="group_gid"></a>`group_gid`

Data type: `Optional[Integer]`

The etcd group GID

Default value: ``undef``

##### <a name="config_path"></a>`config_path`

Data type: `Stdlib::Absolutepath`

The path to etcd YAML configuration

Default value: `'/etc/etcd.yaml'`

##### <a name="config"></a>`config`

Data type: `Hash`

The config values to pass to etcd

Default value: `{'data-dir' => '/var/lib/etcd'}`

##### <a name="max_open_files"></a>`max_open_files`

Data type: `Integer`

The value for systemd LimitNOFILE unit option

Default value: `40000`

